%global __requires_exclude pear\\(/usr/share/php/adodb/adodb.inc.php\\)|pear\\(/usr/share/php-adodb/adodb.inc.php\\)


%define pia_version 3.1

Summary:	Php frontend for rrdtool
Name:		cacti
Version:	0.8.8f
Release:	%mkrel 1
License:	GPL
Group:		System/Servers
URL:		http://www.cacti.net
Source0:	http://www.cacti.net/downloads/%{name}-%{version}.tar.gz
Patch0:		cacti-0.8.8a-PIA-3.1-fhs.diff
Patch1:		cacti-0.8.8a-PIA-3.1-use-external-adodb.diff
Requires:	apache-mod_php >= 2.0.54
Requires:	php-adodb >= 1:4.64-1mdk
Requires:	php-cli
Requires:	php-gd
Requires:	php-mysql
Requires:	php-snmp
Requires:	php-xml
Requires:	php-sockets
Requires:	net-snmp-utils
Requires:	net-snmp
Requires:	rrdtool
BuildArch:	noarch

%description
Cacti is a complete frondend to rrdtool, it stores all of the nessesary
information to create graphs and populate them with data in a MySQL database.

The frontend is completely PHP driven. Along with being able to maintain
Graphs, Data Sources, and Round Robin Archives in a database, cacti handles
the data gathering also. There is also SNMP support for those used to creating
traffic graphs with MRTG.

This is the %{name}-%{version}-PIA-%{pia_version} release that has the
plugin architecture implemented that previous was provided with a patch.

%prep

%setup -q 

%patch0 -p1
%patch1 -p0

rm -rf lib/adodb
find . -type f -name "*.orig" | xargs rm -f

# fix perms
find . -type d | xargs chmod 755
find . -type f | xargs chmod 644
chmod +x scripts/*.{pl,sh}
chmod +x poller.php cmd.php

# no .htaccess file
rm -f cli/.htaccess

%build

%install
install -d -m 755 %{buildroot}%{_datadir}/%{name}
cp *.php %{buildroot}%{_datadir}/%{name}
cp -pr docs %{buildroot}%{_datadir}/%{name}
cp -pr images %{buildroot}%{_datadir}/%{name}
cp -pr install %{buildroot}%{_datadir}/%{name}
cp -pr include %{buildroot}%{_datadir}/%{name}

cp -pr scripts %{buildroot}%{_datadir}/%{name}
cp -pr cli %{buildroot}%{_datadir}/%{name}
cp -pr resource %{buildroot}%{_datadir}/%{name}
cp -pr lib %{buildroot}%{_datadir}/%{name}

install -d -m 755 %{buildroot}%{_datadir}/%{name}/sql
install -m 644 cacti.sql %{buildroot}%{_datadir}/%{name}/sql

install -d -m 755 %{buildroot}%{_datadir}/%{name}/plugins

# configuration
install -d -m 755 %{buildroot}%{_sysconfdir}
mv %{buildroot}%{_datadir}/%{name}/include/config.php \
    %{buildroot}%{_sysconfdir}/%{name}.conf
pushd %{buildroot}%{_datadir}/%{name}/include
ln -s ../../../..%{_sysconfdir}/%{name}.conf config.php
chmod 600 %{buildroot}%{_sysconfdir}/%{name}.conf
popd

perl -pi -e 's|\$url_path = "/";|\$url_path = "/cacti/";|' \
    %{buildroot}%{_sysconfdir}/cacti.conf

# data
install -d -m 755 %{buildroot}%{_localstatedir}/lib/%{name}
pushd %{buildroot}%{_datadir}/%{name}
ln -s ../../..%{_localstatedir}/lib/%{name} rra
popd

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
# Cacti Apache configuration file
Alias /%{name} %{_datadir}/%{name}
<Directory %{_datadir}/%{name}>
    Order allow,deny
    Allow from all
    Require all granted

    Options -FollowSymLinks

    <Files ~ "^(poller.*|cmd).php$">
        Order deny,allow
        Deny from all
    </Files>

    # recommanded value
    php_value memory_limit 128M
</Directory>

<Directory %{_datadir}/%{name}/scripts>
    Order deny,allow
    Deny from all
</Directory>

<Directory %{_datadir}/%{name}/cli>
    Order deny,allow
    Deny from all
</Directory>

<Directory %{_datadir}/%{name}/resource>
    Order deny,allow
    Deny from all
</Directory>

<Directory %{_datadir}/%{name}/lib>
    Order deny,allow
    Deny from all
</Directory>

<Directory %{_datadir}/%{name}/sql>
    Order deny,allow
    Deny from all
</Directory>
EOF

# cron task
install -d -m 755 %{buildroot}%{_sysconfdir}/cron.d
cat > %{buildroot}%{_sysconfdir}/cron.d/%{name} <<EOF
*/5 * * * *     apache     php %{_datadir}/%{name}/poller.php > /dev/null 2>&1
EOF

# logs
install -d -m 755 %{buildroot}%{_var}/log/%{name}
touch %{buildroot}%{_localstatedir}/log/%{name}/%{name}.log
install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/%{name} <<EOF
%{_var}/log/%{name}/*.log {
    missingok
    compress
}
EOF

rm -rf %{buildroot}%{_datadir}/%{name}/lib/adodb

cat > README.mdv <<EOF
Mandriva RPM specific notes

setup
-----
The setup used here differs from default one, to achieve better FHS compliance.
- the constant files are in %{_datadir}/%{name}
- the configuration file is /etc/cacti.conf
- the variable files are in %{_localstatedir}/lib/%{name}
- the log files are in %{_localstatedir}/log/%{name}

post-installation
-----------------
You have to create the MySQL database using the following files:
- /usr/share/cacti/sql/cacti.sql

Warning, apache will segfault if cacti is run with an empty database...

Additional useful packages
--------------------------
- a MySQL database, either locale or remote
EOF

%pre
if [ $1 = "2" ]; then
    # fix for old setup
    if [ -L %{_var}/www/%{name}/include ]; then
        rm -f %{_var}/www/%{name}/include
    fi
fi


%files
%doc LICENSE README.mdv docs/CHANGELOG docs/CONTRIB docs/README
%attr(640,root,apache) %config(noreplace) %{_webappconfdir}/%{name}.conf
%attr(640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/cron.d/%{name}
%{_datadir}/%{name}
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{name}
%attr(-,apache,apache) %dir %{_localstatedir}/log/%{name}
%attr(-,apache,apache) %{_localstatedir}/log/%{name}/%{name}.log




%changelog
* Mon Jul 20 2015 luigiwalser <luigiwalser> 0.8.8f-1.mga5
+ Revision: 855657
- 0.8.8f
- 0.8.8e (fixes CVE-2015-4634)
- 0.8.8d (fixes CVE-2015-4342 and other security issues and bugs)

* Fri Nov 28 2014 oden <oden> 0.8.8c-1.mga5
+ Revision: 799743
- drop all, really...
- 0.8.8c
- drop all security patches. these has been fixed in 0.8.8c

* Wed Oct 15 2014 umeabot <umeabot> 0.8.8b-8.mga5
+ Revision: 750327
- Second Mageia 5 Mass Rebuild

* Sat Oct 04 2014 luigiwalser <luigiwalser> 0.8.8b-7.mga5
+ Revision: 736695
- update CVE-2014-4002 patch from debian
- add patches from debian to fix CVE-2014-502[56] and CVE-2014-526[12]

* Wed Oct 01 2014 tv <tv> 0.8.8b-6.mga5
+ Revision: 733983
- rebuild for pear deps

* Tue Sep 16 2014 umeabot <umeabot> 0.8.8b-5.mga5
+ Revision: 678278
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes

* Fri Jul 11 2014 oden <oden> 0.8.8b-4.mga5
+ Revision: 651308
- also add the patches...
- P5: security fix for CVE-2014-2326
- P6: security fix for CVE-2014-2328
- P7: security fix for CVE-2014-2708
- P8: security fix for CVE-2014-2709
- P9: security fix for CVE-2014-4002

* Sat Oct 19 2013 umeabot <umeabot> 0.8.8b-3.mga4
+ Revision: 534293
- Mageia 4 Mass Rebuild

* Tue Sep 10 2013 oden <oden> 0.8.8b-2.mga4
+ Revision: 477109
- P2: fix regression in the CVE-2013-1435 fix (debian)
- P3: security fix for CVE-2013-5588 (debian)
- P4: security fix for CVE-2013-5589 (debian)

* Wed Aug 07 2013 oden <oden> 0.8.8b-1.mga4
+ Revision: 464350
- 0.8.8b:
 - bug: Fixed issue with custom data source information being lost when saved from edit
 - bug: Repopulate the poller cache on new installations
 - bug: Fix issue with poller not escaping the script query path correctly
 - bug: Allow snmpv3 priv proto none
 - bug: Fix issue where host activate may flush the entire poller item cache
 - security: SQL injection and shell escaping issues

* Fri Apr 19 2013 dlucio <dlucio> 0.8.8a-1.mga4
+ Revision: 410477
- Apache 2.4 config fix
- imported package cacti

